    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ----------------------------
    028 * Line2DObjectDescription.java
    029 * ----------------------------
    030 * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: Line2DObjectDescription.java,v 1.3 2005/11/14 11:02:46 mungady Exp $
    036 *
    037 * Changes (from 19-Feb-2003)
    038 * -------------------------
    039 * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040 * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041 *
    042 */
    043
    044package org.jfree.xml.factory.objects;
    045
    046import java.awt.geom.Line2D;
    047
    048/**
    049 * An object-description for a <code>Line2D</code> object.
    050 *
    051 * @author Thomas Morgner
    052 */
    053public class Line2DObjectDescription extends AbstractObjectDescription {
    054
    055    /**
    056     * Creates a new object description.
    057     */
    058    public Line2DObjectDescription() {
    059        super(Line2D.class);
    060        setParameterDefinition("x1", Float.class);
    061        setParameterDefinition("x2", Float.class);
    062        setParameterDefinition("y1", Float.class);
    063        setParameterDefinition("y2", Float.class);
    064    }
    065
    066    /**
    067     * Creates an object based on this description.
    068     *
    069     * @return The object.
    070     */
    071    public Object createObject() {
    072        final Line2D line = new Line2D.Float();
    073
    074        final float x1 = getFloatParameter("x1");
    075        final float x2 = getFloatParameter("x2");
    076        final float y1 = getFloatParameter("y1");
    077        final float y2 = getFloatParameter("y2");
    078        line.setLine(x1, y1, x2, y2);
    079        return line;
    080    }
    081
    082    /**
    083     * Returns a parameter value as a float.
    084     *
    085     * @param param  the parameter name.
    086     *
    087     * @return The float value.
    088     */
    089    private float getFloatParameter(final String param) {
    090        final Float p = (Float) getParameter(param);
    091        if (p == null) {
    092            return 0;
    093        }
    094        return p.floatValue();
    095    }
    096
    097    /**
    098     * Sets the parameters of this description object to match the supplied object.
    099     *
    100     * @param o  the object (should be an instance of <code>Line2D</code>).
    101     *
    102     * @throws ObjectFactoryException if the object is not an instance of <code>Line2D</code>.
    103     */
    104    public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    105        if (!(o instanceof Line2D)) {
    106            throw new ObjectFactoryException("The given object is no java.awt.geom.Line2D.");
    107        }
    108        final Line2D line = (Line2D) o;
    109        final float x1 = (float) line.getX1();
    110        final float x2 = (float) line.getX2();
    111        final float y1 = (float) line.getY1();
    112        final float y2 = (float) line.getY2();
    113
    114        setParameter("x1", new Float(x1));
    115        setParameter("x2", new Float(x2));
    116        setParameter("y1", new Float(y1));
    117        setParameter("y2", new Float(y2));
    118    }
    119}